"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require("react");
var classBuilder_1 = require("./../../utilities/classBuilder");
var grid_1 = require('./../layout/grid');
var Dialog = (function (_super) {
    __extends(Dialog, _super);
    function Dialog() {
        _super.apply(this, arguments);
    }
    Dialog.prototype.closeClicked = function () {
        if (this.props.onClose) {
            this.props.onClose();
        }
    };
    Dialog.prototype.scrollToTop = function () {
        this.dialogContentElement.scrollTop = 0;
    };
    Dialog.prototype.componentDidMount = function () {
        this.dialogContentElement = document.getElementById("dialog-content");
    };
    Dialog.prototype.componentWillReceiveProps = function (newProps) {
        var open = newProps.isOpen;
        if (open && open != this.props.isOpen && this.props.onOpen) {
            this.props.onOpen();
        }
    };
    Dialog.prototype.render = function () {
        var _this = this;
        var classes = classBuilder_1.classNames("dialog-layer", classBuilder_1.cd("open", this.props.isOpen), this.props.layerClass);
        var style = { width: this.props.width || "500px", height: this.props.height || "auto" };
        return (React.createElement("div", {className: classes}, 
            React.createElement("div", {className: "dialog", style: style, role: "dialog", "aria-hidden": !this.props.isOpen, "aria-labelledby": this.props.title, "aria-describedby": this.props.subtitle}, 
                React.createElement(grid_1.Grid, null, 
                    React.createElement(grid_1.Row, {className: classBuilder_1.classNames("dialog-header", classBuilder_1.cd("dialog-header-no-title", !this.props.title)), fixed: true}, 
                        React.createElement(grid_1.Col, {centerContent: { vertical: "center" }}, this.props.title &&
                            React.createElement("div", {className: "flex-override"}, 
                                React.createElement("div", {className: "dialog-titles"}, 
                                    this.props.title && React.createElement("div", {className: "dialog-title"}, this.props.title), 
                                    this.props.subtitle && React.createElement("div", {className: "dialog-subtitle"}, this.props.subtitle))
                            )), 
                        React.createElement(grid_1.Col, {fixed: true}, 
                            React.createElement("div", {className: "close-dialog-button", onClick: function () { return _this.props.xClicked ? _this.props.xClicked() : _this.closeClicked(); }})
                        )), 
                    React.createElement(grid_1.SingleColumnRow, {id: "dialog-content", className: "dialog-content"}, this.props.children))
            )
        ));
    };
    return Dialog;
}(React.Component));
exports.Dialog = Dialog;
