import * as React from "react";
export interface IDatePickerInputProps extends React.Props<DatePickerInput> {
    className?: string;
    locale?: string;
    date?: moment.Moment | string;
    format?: string;
    minDate?: moment.Moment;
    maxDate?: moment.Moment;
    onDateChanged?: (date: moment.Moment) => void;
}
export interface IDatePickerInputState {
    displayedDate?: moment.Moment;
    selectedDate?: moment.Moment;
    pickerBodyVisible?: boolean;
    showOnTop?: boolean;
    isMobile?: boolean;
}
export declare class DatePickerInput extends React.Component<IDatePickerInputProps, IDatePickerInputState> {
    private mouseDownOnCalendar;
    private inputElement;
    private bodyElement;
    private inputElementId;
    private bodyElementId;
    static defaultProps: {
        format: string;
        date: moment.Moment;
        locale: string;
    };
    constructor(props: IDatePickerInputProps);
    onDaySelected(date: moment.Moment): void;
    isEndOfMonth(date: moment.Moment): boolean;
    fallsWithinRange(date: moment.Moment): boolean;
    getDaysInMonth(): any[];
    getDayComponent(notInCurrentMonth: boolean, dayClicked: (d: moment.Moment) => void, date: moment.Moment): JSX.Element;
    changeMonth(increment: number): void;
    checkDate(dateString: string): void;
    componentWillMount(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    checkMobile(width: number): void;
    handleEvent(e: any): void;
    onInputFocus(): void;
    shouldShowOnTop(): void;
    render(): JSX.Element;
}
