"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require("react");
var uiHelpers_1 = require("./../../utilities/uiHelpers");
var classBuilder_1 = require("./../../utilities/classBuilder");
var Container = (function (_super) {
    __extends(Container, _super);
    function Container() {
        _super.apply(this, arguments);
    }
    Container.prototype.render = function () {
        var layoutClasses = uiHelpers_1.LayoutHelpers.HandleLayoutClasses(this.props.margin, this.props.padding);
        var displayClasses = uiHelpers_1.LayoutHelpers.HandleDisplayClasses(this.props.background, this.props.foreground);
        var displayStyles = uiHelpers_1.LayoutHelpers.HandleDisplayStyles(this.props.background, this.props.foreground);
        var classes = classBuilder_1.classNames(layoutClasses, displayClasses);
        if (!classes) {
            classes = null;
        }
        return React.createElement("div", {style: displayStyles, className: classes}, this.props.children);
    };
    return Container;
}(React.Component));
exports.Container = Container;
