import * as React from "react";
import { LayoutProps, DisplayProps, CenterContent, CenterBoth, Responsiveness } from "./../../utilities/uiHelpers";
export interface IGrid extends React.Props<Grid>, LayoutProps, DisplayProps {
    debugMode?: boolean;
    responsive?: Responsiveness;
    className?: string;
    table?: boolean;
}
export declare class Grid extends React.Component<IGrid, any> {
    static defaultProps: {
        responsive: string;
    };
    render(): JSX.Element;
}
export interface IColRow extends IRow {
    centerContent?: CenterContent | CenterBoth;
}
export interface IRow extends React.HTMLProps<Row>, LayoutProps, DisplayProps {
    fixed?: boolean | number;
}
export declare class Row extends React.Component<IRow, any> {
    render(): JSX.Element;
}
export interface ICol extends React.HTMLProps<Col>, LayoutProps, DisplayProps {
    centerContent?: CenterContent | CenterBoth;
    spans?: number;
    fixed?: boolean | number;
}
export declare class Col extends React.Component<ICol, {}> {
    render(): JSX.Element;
}
export declare class SingleColumnRow extends React.Component<IColRow, any> {
    render(): JSX.Element;
}
