"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var _ = require("underscore");
var classBuilder_1 = require("./../../utilities/classBuilder");
var uiHelpers_1 = require("./../../utilities/uiHelpers");
var Grid = (function (_super) {
    __extends(Grid, _super);
    function Grid() {
        _super.apply(this, arguments);
    }
    Grid.prototype.render = function () {
        var responsiveClasses = uiHelpers_1.LayoutHelpers.HandleResponsivenessClasses(this.props.responsive);
        var layoutClasses = uiHelpers_1.LayoutHelpers.HandleLayoutClasses(this.props.margin, this.props.padding);
        var displayClasses = uiHelpers_1.LayoutHelpers.HandleDisplayClasses(this.props.background, this.props.foreground);
        var displayStyles = uiHelpers_1.LayoutHelpers.HandleDisplayStyles(this.props.background, this.props.foreground);
        var originalClassName = this.props.className;
        var attrs = _.omit(this.props, "className");
        var classes = classBuilder_1.classNames(originalClassName, "grid", "fill-container", responsiveClasses, classBuilder_1.cd("grid-debug", this.props.debugMode), classBuilder_1.cd("table-grid", this.props.table), displayClasses, layoutClasses);
        return (React.createElement("div", __assign({}, attrs, {className: classes, style: displayStyles})));
    };
    Grid.defaultProps = {
        responsive: "both"
    };
    return Grid;
}(React.Component));
exports.Grid = Grid;
var Row = (function (_super) {
    __extends(Row, _super);
    function Row() {
        _super.apply(this, arguments);
    }
    Row.prototype.render = function () {
        var layoutClasses = uiHelpers_1.LayoutHelpers.HandleLayoutClasses(this.props.margin, this.props.padding);
        var displayClasses = uiHelpers_1.LayoutHelpers.HandleDisplayClasses(this.props.background, this.props.foreground);
        var displayStyles = uiHelpers_1.LayoutHelpers.HandleDisplayStyles(this.props.background, this.props.foreground);
        var attrs = _.omit(this.props, "className", "fixed");
        var classes = classBuilder_1.classNames(this.props.className, "row", classBuilder_1.cd("no-flex", !!this.props.fixed), displayClasses, layoutClasses);
        if (typeof this.props.fixed === "number") {
            displayStyles = _.extend({ maxHeight: this.props.fixed + "px", height: "100%" }, displayStyles);
        }
        return React.createElement("div", __assign({}, attrs, {className: classes, style: displayStyles}));
    };
    return Row;
}(React.Component));
exports.Row = Row;
var Col = (function (_super) {
    __extends(Col, _super);
    function Col() {
        _super.apply(this, arguments);
    }
    Col.prototype.render = function () {
        var layoutClasses = uiHelpers_1.LayoutHelpers.HandleLayoutClasses(this.props.margin, this.props.padding);
        var displayClasses = uiHelpers_1.LayoutHelpers.HandleDisplayClasses(this.props.background, this.props.foreground);
        var displayStyles = uiHelpers_1.LayoutHelpers.HandleDisplayStyles(this.props.background, this.props.foreground);
        var centerClasses = uiHelpers_1.LayoutHelpers.GetAlignment(this.props.centerContent);
        var classes = classBuilder_1.classNames("col", this.props.className, classBuilder_1.cd("no-flex", this.props.fixed !== undefined), classBuilder_1.cd("col" + this.props.spans, this.props.spans !== undefined), displayClasses, layoutClasses, centerClasses);
        var attrs = _.omit(this.props, "fixed", "spans");
        if (typeof this.props.fixed === "number") {
            displayStyles = _.extend({ maxWidth: this.props.fixed + "px", width: "100%" }, displayStyles);
        }
        return React.createElement("div", __assign({}, attrs, {className: classes, style: displayStyles}));
    };
    return Col;
}(React.Component));
exports.Col = Col;
var SingleColumnRow = (function (_super) {
    __extends(SingleColumnRow, _super);
    function SingleColumnRow() {
        _super.apply(this, arguments);
    }
    SingleColumnRow.prototype.render = function () {
        var layoutClasses = uiHelpers_1.LayoutHelpers.HandleLayoutClasses(this.props.margin, this.props.padding);
        var displayClasses = uiHelpers_1.LayoutHelpers.HandleDisplayClasses(this.props.background, this.props.foreground);
        var displayStyles = uiHelpers_1.LayoutHelpers.HandleDisplayStyles(this.props.background, this.props.foreground);
        var centerClasses = uiHelpers_1.LayoutHelpers.GetAlignment(this.props.centerContent);
        var classes = classBuilder_1.classNames("row", classBuilder_1.cd("no-flex", this.props.fixed !== undefined), this.props.className, displayClasses, layoutClasses);
        return (React.createElement("div", __assign({}, this.props, {className: classes, style: displayStyles}), 
            React.createElement("div", {className: classBuilder_1.classNames('col', centerClasses)}, this.props.children)
        ));
    };
    return SingleColumnRow;
}(React.Component));
exports.SingleColumnRow = SingleColumnRow;
