"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require("react");
var uiHelpers_1 = require("./../../utilities/uiHelpers");
var classBuilder_1 = require("./../../utilities/classBuilder");
var Heading = (function (_super) {
    __extends(Heading, _super);
    function Heading() {
        _super.apply(this, arguments);
    }
    Heading.prototype.render = function () {
        var layoutClasses = uiHelpers_1.LayoutHelpers.HandleLayoutClasses(this.props.margin, this.props.padding);
        var displayClasses = uiHelpers_1.LayoutHelpers.HandleDisplayClasses(this.props.background, this.props.foreground);
        var displayStyles = uiHelpers_1.LayoutHelpers.HandleDisplayStyles(this.props.background, this.props.foreground);
        var classes = classBuilder_1.classNames(classBuilder_1.cd(this.props.styleType, this.props.styleType !== this.props.elementType), layoutClasses, displayClasses);
        if (!classes) {
            classes = null;
        }
        switch (this.props.elementType) {
            case "h1":
                return React.createElement("h1", {style: displayStyles, className: classes}, this.props.children);
            case "h2":
                return React.createElement("h2", {style: displayStyles, className: classes}, this.props.children);
            case "h3":
                return React.createElement("h3", {style: displayStyles, className: classes}, this.props.children);
            case "div":
                return React.createElement("div", {style: displayStyles, className: classes}, this.props.children);
        }
    };
    Heading.defaultProps = {
        elementType: "h3",
        styleType: "heading3"
    };
    return Heading;
}(React.Component));
exports.Heading = Heading;
